routes/admin.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Admin Routes
|--------------------------------------------------------------------------
|
| Here is where you can register admin routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" and "admin" middleware groups. Now create a great admin panel !
|
*/

Route::get('/', 'AdminController@index')->name('dashboard');

Route::prefix('settings')->name('settings.')->middleware('can:admin.settings')->group(function () {
    Route::get('/', 'SettingsController@index')->name('index');
    Route::post('/update', 'SettingsController@update')->name('update');

    Route::post('/cache/clear', 'SettingsController@clearCache')->name('cache.clear');
    Route::post('/cache/advanced/enable', 'SettingsController@enableAdvancedCache')->name('cache.advanced.enable');
    Route::post('/cache/advanced/clear', 'SettingsController@disableAdvancedCache')->name('cache.advanced.clear');

    Route::get('/performance', 'SettingsController@performance')->name('performance');
    Route::get('/storage/link', 'SettingsController@linkStorage')->name('link-storage');

    Route::get('/seo', 'SettingsController@seo')->name('seo');
    Route::post('/seo/update', 'SettingsController@updateSeo')->name('seo.update');

    Route::get('/auth', 'SettingsController@auth')->name('auth');
    Route::post('/auth/update', 'SettingsController@updateauth')->name('auth.update');
    Route::post('/security/update', 'SettingsController@updateSecurity')->name('security.update');

    Route::get('/mail', 'SettingsController@mail')->name('mail');
    Route::post('/mail/update', 'SettingsController@updateMail')->name('mail.update');
    Route::post('/mail/test', 'SettingsController@sendTestMail')->name('mail.send');

    Route::get('/maintenance', 'SettingsController@maintenance')->name('maintenance');
    Route::post('/maintenance/update', 'SettingsController@updateMaintenance')->name('maintenance.update');
});

Route::prefix('users')->name('users.')->middleware('can:admin.users')->group(function () {
    Route::post('/{user}/verify', 'UserController@verifyEmail')->name('verify');
    Route::post('/{user}/2fa', 'UserController@disable2fa')->name('2fa');
});

Route::prefix('themes')->name('themes.')->middleware('can:admin.themes')->group(function () {
    Route::get('/', 'ThemeController@index')->name('index');
    Route::post('/reload', 'ThemeController@reload')->name('reload');
    Route::post('/change/{theme?}', 'ThemeController@changeTheme')->name('change');
    Route::prefix('/{theme}/config')->group(function () {
        Route::get('/', 'ThemeController@edit')->name('edit');
        Route::post('/', 'ThemeController@config')->name('config');
    });
    Route::post('/{theme}/update', 'ThemeController@update')->name('update');
    Route::post('/{themeId}/download', 'ThemeController@download')->name('download');
    Route::delete('/{theme}', 'ThemeController@delete')->name('delete');
});

Route::prefix('plugins')->name('plugins.')->middleware('can:admin.plugins')->group(function () {
    Route::get('/', 'PluginController@index')->name('index');
    Route::post('/reload', 'PluginController@reload')->name('reload');
    Route::post('/{plugin}/enable', 'PluginController@enable')->name('enable');
    Route::post('/{plugin}/disable', 'PluginController@disable')->name('disable');
    Route::post('/{plugin}/update', 'PluginController@update')->name('update');
    Route::post('/{pluginId}/download', 'PluginController@download')->name('download');
    Route::delete('/{plugin}', 'PluginController@delete')->name('delete');
});

Route::prefix('update')->name('update.')->middleware('can:admin.update')->group(function () {
    Route::get('/', 'UpdateController@index')->name('index');
    Route::post('/fetch', 'UpdateController@fetch')->name('fetch');
    Route::post('/download', 'UpdateController@download')->name('download');
    Route::post('/install', 'UpdateController@install')->name('install');
});

Route::resource('navbar-elements', 'NavbarController')->except('show')->middleware('can:admin.navbar');
Route::post('/navbar-elements/order', 'NavbarController@updateOrder')->name('navbar-elements.update-order')->middleware('can:admin.navbar');

Route::resource('users', 'UserController')->except('show')->middleware('can:admin.users');
Route::resource('roles', 'RoleController')->except('show')->middleware('can:admin.roles');
Route::post('/roles/power', 'RoleController@updatePower')->name('roles.update-power')->middleware('can:admin.roles');

Route::resource('bans', 'BanController')->only('index')->middleware('can:admin.users');
Route::resource('users.bans', 'BanController')->only(['store', 'destroy'])->middleware('can:admin.users');

Route::resource('pages', 'PageController')->except('show')->middleware('can:admin.pages');
Route::resource('posts', 'PostController')->except('show')->middleware('can:admin.posts');
Route::resource('images', 'ImageController')->except('show')->middleware('can:admin.images');

Route::resource('pages.attachments', 'PageAttachmentController')->only('store');
Route::resource('posts.attachments', 'PostAttachmentController')->only('store');
Route::post('pages/attachments/{pendingId}', 'PageAttachmentController@pending')->name('pages.attachments.pending');
Route::post('posts/attachments/{pendingId}', 'PostAttachmentController@pending')->name('posts.attachments.pending');

Route::resource('servers', 'ServerController')->except('show');
Route::post('/servers/{server}/verify/azlink', 'ServerController@verifyAzLink')->name('servers.verify-azlink');
Route::post('/servers/default', 'ServerController@changeDefault')->name('servers.change-default');

Route::post('logs/clear', 'ActionLogController@clear')->name('logs.clear')->middleware('can:admin.logs');
Route::resource('logs', 'ActionLogController')->only(['index'])->middleware('can:admin.logs');

Route::fallback('AdminController@fallback');

routes/web.php
<?php

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', 'HomeController@index')->name('home');
Route::get('/maintenance', 'HomeController@maintenance')->name('maintenance');

Route::prefix('user')->group(function () {
    Auth::routes([
        'verify' => true,
        'register' => setting('register', true),
    ]);

    Route::get('/login/callback', 'Auth\LoginController@handleProviderCallback')->name('login.callback');

    Route::prefix('/2fa')->name('login.')->group(function () {
        Route::get('/', 'Auth\LoginController@showCodeForm')->name('2fa');
        Route::post('/', 'Auth\LoginController@verifyCode')->name('2fa-verify');
    });
});

Route::prefix('users')->name('users.')->middleware('auth')->group(function () {
    Route::get('/search', 'UserController@search')->name('search');
});

Route::prefix('profile')->name('profile.')->middleware('auth')->group(function () {
    Route::get('/', 'ProfileController@index')->name('index');

    Route::post('/theme', 'ProfileController@theme')->name('theme');

    Route::post('/email', 'ProfileController@updateEmail')->name('email');
    Route::post('/password', 'ProfileController@updatePassword')->name('password');

    Route::prefix('2fa')->name('2fa.')->group(function () {
        Route::get('/', 'ProfileController@show2fa')->name('index');

        Route::post('/', 'ProfileController@enable2fa')->name('enable');
        Route::post('/disable', 'ProfileController@disable2fa')->name('disable');
    });

    Route::post('/money/transfer', 'ProfileController@transferMoney')->name('transfer-money');
});

Route::prefix('notifications')->name('notifications.')->middleware('auth')->group(function () {
    Route::post('/{notification}/read', 'NotificationController@markAsRead')->name('read');
    Route::post('/read', 'NotificationController@markAllAsRead')->name('read.all');
});

Route::prefix('news')->name('posts.')->group(function () {
    Route::get('/', 'PostController@index')->name('index');
    Route::get('/{post:slug}', 'PostController@show')->name('show');

    Route::prefix('/{post}/like')->middleware('auth')->group(function () {
        Route::post('/', 'PostLikeController@addLike')->name('like');
        Route::delete('/', 'PostLikeController@removeLike')->name('dislike');
    });
});

Route::resource('posts.comments', 'PostCommentController')->middleware(['auth', 'verified'])->only('store', 'destroy');

Route::get('/{page:slug}', 'PageController@show')->name('pages.show');

app/Models/Image.php
<?php

namespace Azuriom\Models;

use Azuriom\Models\Traits\Loggable;
use Illuminate\Database\Eloquent\Model;

/**
 * @property int $id
 * @property string $name
 * @property string $file
 * @property string $type
 * @property \Carbon\Carbon $created_at
 * @property \Carbon\Carbon $updated_at
 */
class Image extends Model
{
    use Loggable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'file', 'type',
    ];

    /**
     * Get the slug of this image.
     */
    public function getSlug()
    {
        return pathinfo($this->file, PATHINFO_FILENAME);
    }

    public function getExtension()
    {
        return pathinfo($this->file, PATHINFO_EXTENSION);
    }

    public function url()
    {
        return image_url($this->file);
    }
}

app/Http/Controllers/Admin/ImageController.php
<?php

namespace Azuriom\Http\Controllers\Admin;

use Azuriom\Http\Controllers\Controller;
use Azuriom\Http\Requests\ImageRequest;
use Azuriom\Models\Image;
use Illuminate\Support\Facades\Storage;
use Illuminate\Support\Facades\Validator;
use Illuminate\Validation\Rule;

class ImageController extends Controller
{
    /**
     * The storage path for uploaded images.
     *
     * @var string
     */
    protected $imagesPath = 'img';

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('admin.images.index', ['images' => Image::paginate(25)]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('admin.images.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Azuriom\Http\Requests\ImageRequest  $request
     * @return \Illuminate\Http\Response
     */
    public function store(ImageRequest $request)
    {
        $file = $request->file('image');
        $mimeType = $file->getMimeType();
        $extension = $this->normalizeExtensions($file->extension());
        $fileName = $request->input('slug').'.'.$extension;

        Validator::make(['slug' => $fileName], [
            'slug' => [Rule::unique('images', 'file')],
        ])->validate();

        $file->storeAs($this->imagesPath, $fileName, 'public');

        Image::create([
            'name' => $request->input('name'),
            'file' => $fileName,
            'type' => $mimeType,
        ]);

        return redirect()->route('admin.images.index')->with('success', trans('admin.images.status.created'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \Azuriom\Models\Image  $image
     * @return \Illuminate\Http\Response
     */
    public function edit(Image $image)
    {
        return view('admin.images.edit', ['image' => $image]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Azuriom\Http\Requests\ImageRequest  $request
     * @param  \Azuriom\Models\Image  $image
     * @return \Illuminate\Http\Response
     */
    public function update(ImageRequest $request, Image $image)
    {
        $fileName = $request->input('slug').'.'.$image->getExtension();

        Validator::make(['slug' => $fileName], [
            'slug' => [Rule::unique('images', 'file')->ignore($image->file, 'file')],
        ])->validate();

        if ($image->file !== $fileName) {
            Storage::disk('public')->move($this->getImagesPath($image->file), $this->getImagesPath($fileName));
        }

        $image->update([
            'name' => $request->input('name'),
            'file' => $fileName,
        ]);

        return redirect()->route('admin.images.index')->with('success', trans('admin.images.status.updated'));
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \Azuriom\Models\Image  $image
     * @return \Illuminate\Http\Response
     *
     * @throws \Exception
     */
    public function destroy(Image $image)
    {
        Storage::disk('public')->delete($this->getImagesPath($image->file));

        $image->delete();

        return redirect()->route('admin.images.index')->with('success', trans('admin.images.status.deleted'));
    }

    protected function getImagesPath(string $fileName)
    {
        return "{$this->imagesPath}/{$fileName}";
    }

    protected function normalizeExtensions(string $name)
    {
        return str_replace('jpeg', 'jpg', strtolower($name));
    }
}

resources/views/admin/images/create.blade.php
@extends('admin.layouts.admin')

@section('title', trans('admin.images.title-create'))

@section('content')
    <div class="card shadow mb-4">
        <div class="card-body">
            <form action="{{ route('admin.images.store') }}" method="POST" enctype="multipart/form-data">
                @csrf

                <div class="form-group">
                    <label for="nameInput">{{ trans('messages.fields.name') }}</label>
                    <input type="text" class="form-control @error('name') is-invalid @enderror" id="nameInput" name="name" value="{{ old('name') }}" required>

                    @error('name')
                    <span class="invalid-feedback" role="alert"><strong>{{ $message }}</strong></span>
                    @enderror
                </div>

                <div class="form-group">
                    <label for="slugInput">{{ trans('messages.fields.slug') }}</label>
                    <div class="input-group">
                        <div class="input-group-prepend">
                            <div class="input-group-text">{{ image_url() }}/</div>
                        </div>
                        <input type="text" class="form-control @error('slug') is-invalid @enderror" id="slugInput" name="slug" value="{{ old('slug') }}" required>
                        <div class="input-group-append">
                            <div class="input-group-text">.(jpg|png|gif|svg|webp)</div>
                        </div>

                        @error('slug')
                        <span class="invalid-feedback" role="alert"><strong>{{ $message }}</strong></span>
                        @enderror
                    </div>
                </div>

                <div class="form-group">
                    <label for="imageInput">{{ trans('messages.fields.image') }}</label>
                    <div class="custom-file">
                        <input type="file" class="custom-file-input @error('image') is-invalid @enderror" id="imageInput" name="image" accept=".jpg,.jpeg,.jpe,.png,.gif,.bmp,.svg,.webp" data-image-preview="filePreview" required>
                        <label class="custom-file-label" for="customFile" data-browse="{{ trans('messages.actions.browse') }}">{{ trans('messages.actions.choose-file') }}</label>

                        @error('image')
                        <span class="invalid-feedback" role="alert"><strong>{{ $message }}</strong></span>
                        @enderror
                    </div>

                    <img src="#" class="mt-2 img-fluid rounded img-preview d-none" alt="Image" id="filePreview">
                </div>

                <button type="submit" class="btn btn-primary">
                    <i class="fas fa-save"></i> {{ trans('messages.actions.save') }}
                </button>
            </form>
        </div>
    </div>
@endsection

resources/views/admin/images/edit.blade.php
@extends('admin.layouts.admin')

@section('title', trans('admin.images.title-edit', ['image' => $image->name]))

@section('content')
    <div class="card shadow mb-4">
        <div class="card-body">
            <form action="{{ route('admin.images.update', $image) }}" method="POST">
                @method('PATCH')
                @csrf

                <div class="form-group">
                    <label for="nameInput">{{ trans('messages.fields.name') }}</label>
                    <input type="text" class="form-control @error('name') is-invalid @enderror" id="nameInput" name="name" value="{{ old('name', $image->name) }}" required>

                    @error('name')
                    <span class="invalid-feedback" role="alert"><strong>{{ $message }}</strong></span>
                    @enderror
                </div>

                <div class="form-group">
                    <label for="slugInput">{{ trans('messages.fields.slug') }}</label>
                    <div class="input-group">
                        <div class="input-group-prepend">
                            <div class="input-group-text">{{ image_url() }}/</div>
                        </div>
                        <input type="text" class="form-control @error('slug') is-invalid @enderror" id="slugInput" name="slug" value="{{ old('slug', $image->getSlug()) }}" required>
                        <div class="input-group-append">
                            <div class="input-group-text">.{{ $image->getExtension() }}</div>
                        </div>

                        @error('slug')
                        <span class="invalid-feedback" role="alert"><strong>{{ $message }}</strong></span>
                        @enderror
                    </div>
                </div>

                <div class="form-group">
                    <label for="textArea">{{ trans('messages.fields.image') }}</label>

                    <div>
                        <img src="{{ $image->url() }}" class="img-fluid rounded img-preview" alt="{{ $image->name }}">
                    </div>
                </div>
                <button type="submit" class="btn btn-primary">
                    <i class="fas fa-save"></i> {{ trans('messages.actions.save') }}
                </button>

                <a href="{{ route('admin.images.destroy', $image) }}" class="btn btn-danger" data-confirm="delete">
                    <i class="fas fa-trash"></i> {{ trans('messages.actions.delete') }}
                </a>
            </form>
        </div>
    </div>
@endsection

resources/views/admin/images/index.blade.php
@extends('admin.layouts.admin')

@section('title', trans('admin.images.title'))

@section('content')
    <div class="card shadow mb-4">
        <div class="card-body">
            <div class="table-responsive">
                <table class="table">
                    <thead>
                    <tr>
                        <th scope="col">#</th>
                        <th scope="col">{{ trans('messages.fields.image') }}</th>
                        <th scope="col">{{ trans('messages.fields.name') }}</th>
                        <th scope="col">{{ trans('messages.fields.file') }}</th>
                        <th scope="col">{{ trans('messages.fields.action') }}</th>
                    </tr>
                    </thead>
                    <tbody>

                    @foreach($images as $image)
                        <tr>
                            <th scope="row">{{ $image->id }}</th>
                            <td>
                                <img src="{{ $image->url() }}" class="img-small rounded" alt="{{ $image->name }}">
                            </td>
                            <td>{{ $image->name }}</td>
                            <td>
                                <a href="{{ $image->url() }}" target="_blank" rel="noopener noreferrer">
                                    {{ $image->file }}
                                </a>
                            </td>
                            <td>
                                <a href="{{ route('admin.images.edit', $image) }}" class="mx-1" title="{{ trans('messages.actions.edit') }}" data-toggle="tooltip"><i class="fas fa-edit"></i></a>
                                <a href="{{ route('admin.images.destroy', $image) }}" class="mx-1" title="{{ trans('messages.actions.delete') }}" data-toggle="tooltip" data-confirm="delete"><i class="fas fa-trash"></i></a>
                            </td>
                        </tr>
                    @endforeach

                    </tbody>
                </table>
            </div>

            {{ $images->links() }}

            <a class="btn btn-primary" href="{{ route('admin.images.create') }}">
                <i class="fas fa-upload"></i> {{ trans('messages.actions.add') }}
            </a>
        </div>
    </div>
@endsection